#include <pluginlib/class_list_macros.h>
#include <ros/ros.h>

#include "ultrasonic/Ultrasonic.h"

#include "car/ussDataMsg.h"

PLUGINLIB_EXPORT_CLASS(car::Ultrasonic, nodelet::Nodelet
);

namespace car
{

Ultrasonic::Ultrasonic()
    : messageOStream(nh, "Ultrasonic")
      , sensor(UltrasonicSensor::DEVICE_ADDRESS1)
      , streamMedianFilter(5)
{}

void Ultrasonic::onInit()
{
    messageOStream.write("onInit", "START");

    ussData = nh.advertise<ussDataMsg>("ussData", 1);
    //sensor.init();
    timer = networking::time::Timer::create(net);
    timer->startPeriodicTimeout(
        std::chrono::milliseconds(UltrasonicSensor::DELAY),
        [&]
        {
            ussDataMsg msg;
            //auto distance = streamMedianFilter.moveWindow(sensor.getDistance());
            static int distance = 0;
            distance++;
            msg.distance = distance;
            msg.timestamp = ros::Time::now();
            ussData.publish(msg);
        });

    messageOStream.write("onInit", "END");
}

}
